/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

   ludovic.apvrille AT enst.fr

   This software is a computer program whose purpose is to allow the
   edition of TURTLE analysis, design and deployment diagrams, to
   allow the generation of RT-LOTOS or Java code from this diagram,
   and at last to allow the analysis of formal validation traces
   obtained from external tools, e.g. RTL from LAAS-CNRS and CADP
   from INRIA Rhone-Alpes.

   This software is governed by the CeCILL  license under French law and
   abiding by the rules of distribution of free software.  You can  use,
   modify and/ or redistribute the software under the terms of the CeCILL
   license as circulated by CEA, CNRS and INRIA at the following URL
   "http://www.cecill.info".

   As a counterpart to the access to the source code and  rights to copy,
   modify and redistribute granted by the license, users are provided only
   with a limited warranty  and the software's author,  the holder of the
   economic rights,  and the successive licensors  have only  limited
   liability.

   In this respect, the user's attention is drawn to the risks associated
   with loading,  using,  modifying and/or developing or reproducing the
   software by the user in light of its specific status of free software,
   that may mean  that it is complicated to manipulate,  and  that  also
   therefore means  that it is reserved for developers  and  experienced
   professionals having in-depth computer knowledge. Users are therefore
   encouraged to load and test the software's suitability as regards their
   requirements in conditions enabling the security of their systems and/or
   data to be ensured and,  more generally, to use and operate it in the
   same conditions as regards security.

   The fact that you are presently reading this means that you have had
   knowledge of the CeCILL license and that you accept its terms.

   /**
   * Class JPanelTransactions
   * Creation: 23/05/2016
   * version 1.0 23/05/2016
   * @author Ludovic APVRILLE
   * @see
   */

package ui.interactivesimulation;

//import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;


import myutil.*;
import ui.*;
import ui.file.*;

import tmltranslator.*;

import launcher.*;
import remotesimulation.*;

import org.w3c.dom.*;
import org.xml.sax.*;
import javax.xml.parsers.*;


public  class JPanelTransactions extends JPanel  {


    private JFrameInteractiveSimulation jfis;
    private TransactionTableModel ttm;
    private JButton updateTransactionInformationButton;
    private JScrollPane jspTransactionInfo;
    

    private JTextField nbOfTransactions;
    private int defaultNbOfTransactions;



    public JPanelTransactions(JFrameInteractiveSimulation _jfis, int _defaultNbOfTransactions) {
        super();

        jfis = _jfis;
	defaultNbOfTransactions = _defaultNbOfTransactions;

        makeComponents();
        setComponents();
    }

    public void makeComponents() {
	TableSorter sorterPI;
	JTable jtablePI;
	
        GridBagLayout gridbag2 = new GridBagLayout();
        GridBagConstraints c2 = new GridBagConstraints();
        setLayout(gridbag2);
        setBorder(new javax.swing.border.TitledBorder("Managing transactions"));

	ttm = new TransactionTableModel(jfis);
	sorterPI = new TableSorter(ttm);
        jtablePI = new JTable(sorterPI);
        sorterPI.setTableHeader(jtablePI.getTableHeader());
        ((jtablePI.getColumnModel()).getColumn(0)).setPreferredWidth(100);
        ((jtablePI.getColumnModel()).getColumn(1)).setPreferredWidth(100);
        ((jtablePI.getColumnModel()).getColumn(2)).setPreferredWidth(150);
        ((jtablePI.getColumnModel()).getColumn(3)).setPreferredWidth(100);
        ((jtablePI.getColumnModel()).getColumn(4)).setPreferredWidth(100);
	((jtablePI.getColumnModel()).getColumn(5)).setPreferredWidth(100);
	((jtablePI.getColumnModel()).getColumn(6)).setPreferredWidth(100);
        jtablePI.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        jspTransactionInfo = new JScrollPane(jtablePI);
        jspTransactionInfo.setWheelScrollingEnabled(true);
        jspTransactionInfo.getVerticalScrollBar().setUnitIncrement(10);
        jspTransactionInfo.setPreferredSize(new Dimension(500, 300));

	
        c2.gridwidth = GridBagConstraints.REMAINDER; //end row
        c2.fill = GridBagConstraints.BOTH;
        c2.gridheight = 5;
        c2.weighty = 10.0;
        c2.weightx = 10.0;
        add(jspTransactionInfo, c2);

        // 2nd line panel2
        c2.weighty = 1.0;
        c2.weightx = 1.0;
        c2.fill = GridBagConstraints.BOTH;
        c2.gridheight = 1;
        add(new JLabel(""), c2);
	add(new JLabel("# of transactions per node:"), c2);

        c2.gridwidth = GridBagConstraints.REMAINDER; //end row
        c2.fill = GridBagConstraints.HORIZONTAL;

		nbOfTransactions = new JTextField(Integer.toString(defaultNbOfTransactions), defaultNbOfTransactions);
        add(nbOfTransactions, c2);

        add(new JLabel(" "), c2);

	updateTransactionInformationButton = new JButton(jfis.actions[InteractiveSimulationActions.ACT_UPDATE_TRANSACTIONS]);
	add(updateTransactionInformationButton, c2);

    }

    public void setComponents() {
        
    }

    public TransactionTableModel getTableModel() {
	return ttm;
    }

    public int getNbOfTransactions() {
	
	try {
	    defaultNbOfTransactions = Integer.decode(nbOfTransactions.getText()).intValue();
	} catch (Exception e) {
	    //TraceManager.addDev(nbOfTransactions.getText());
	    //TraceManager.addDev("Invalid default transaction");
	    defaultNbOfTransactions = 0;
	}
	return defaultNbOfTransactions;
    }

    public void setData(Vector<SimulationTransaction> _trans) {
	if (ttm != null) {
	    ttm.setData(_trans);
	}
    }

} // Class
